
import { Scene, ColorRepresentation, Vector3 } from 'three';

declare class PointXY {
    x: number;
    y: number;
    private readonly _PointXY;
    constructor(x?: number, y?: number);
}
declare class PointXYZ {
    x: number;
    y: number;
    z: number;
    private readonly _PointXYZ;
    constructor(x?: number, y?: number, z?: number);
}
declare class PointXYZI {
    x: number;
    y: number;
    z: number;
    intensity: number;
    private readonly _PointXYZI;
    constructor(x?: number, y?: number, z?: number, intensity?: number);
}
declare class PointXYZL {
    x: number;
    y: number;
    z: number;
    label: number;
    private readonly _PointXYZL;
    constructor(x?: number, y?: number, z?: number, label?: number);
}
declare class InterestPoint {
    x: number;
    y: number;
    z: number;
    strength: number;
    private readonly _InterestPoint;
    constructor(x?: number, y?: number, z?: number, strength?: number);
}
declare class PointXYZRGB {
    x: number;
    y: number;
    z: number;
    r: number;
    g: number;
    b: number;
    private readonly _PointXYZRGB;
    constructor(x?: number, y?: number, z?: number, r?: number, g?: number, b?: number);
}
declare class PointXYZRGBA {
    x: number;
    y: number;
    z: number;
    r: number;
    g: number;
    b: number;
    a: number;
    private readonly _PointXYZRGBA;
    constructor(x?: number, y?: number, z?: number, r?: number, g?: number, b?: number, a?: number);
}
declare class PointXYZRGBL {
    x: number;
    y: number;
    z: number;
    r: number;
    g: number;
    b: number;
    label: number;
    private readonly _PointXYZRGBL;
    constructor(x?: number, y?: number, z?: number, r?: number, g?: number, b?: number, label?: number);
}
declare class Normal {
    normalX: number;
    normalY: number;
    normalZ: number;
    curvature: number;
    private readonly _Normal;
    constructor(normalX?: number, normalY?: number, normalZ?: number, curvature?: number);
}
declare class PointNormal {
    x: number;
    y: number;
    z: number;
    normalX: number;
    normalY: number;
    normalZ: number;
    curvature: number;
    private readonly _PointNormal;
    constructor(x?: number, y?: number, z?: number, normalX?: number, normalY?: number, normalZ?: number, curvature?: number);
}
declare class PointXYZLNormal {
    x: number;
    y: number;
    z: number;
    label: number;
    normalX: number;
    normalY: number;
    normalZ: number;
    curvature: number;
    private readonly _PointXYZLNormal;
    constructor(x?: number, y?: number, z?: number, label?: number, normalX?: number, normalY?: number, normalZ?: number, curvature?: number);
}
declare class PointXYZINormal {
    x: number;
    y: number;
    z: number;
    intensity: number;
    normalX: number;
    normalY: number;
    normalZ: number;
    curvature: number;
    private readonly _PointXYZINormal;
    constructor(x?: number, y?: number, z?: number, intensity?: number, normalX?: number, normalY?: number, normalZ?: number, curvature?: number);
}
declare class PointXYZRGBNormal {
    x: number;
    y: number;
    z: number;
    r: number;
    g: number;
    b: number;
    normalX: number;
    normalY: number;
    normalZ: number;
    curvature: number;
    private readonly _PointXYZRGBNormal;
    constructor(x?: number, y?: number, z?: number, r?: number, g?: number, b?: number, normalX?: number, normalY?: number, normalZ?: number, curvature?: number);
}
declare class PointSurfel {
    x: number;
    y: number;
    z: number;
    normalX: number;
    normalY: number;
    normalZ: number;
    r: number;
    g: number;
    b: number;
    a: number;
    radius: number;
    confidence: number;
    curvature: number;
    private readonly _PointSurfel;
    constructor(x?: number, y?: number, z?: number, normalX?: number, normalY?: number, normalZ?: number, r?: number, g?: number, b?: number, a?: number, radius?: number, confidence?: number, curvature?: number);
}
declare type PointTypes = PointXY | PointXYZ | PointXYZI | InterestPoint | PointXYZL | PointXYZRGB | PointXYZRGBA | PointXYZRGBL | Normal | PointNormal | PointXYZRGBNormal | PointXYZINormal | PointXYZLNormal | PointSurfel;
declare type PointTypesTypeof = typeof PointXY | typeof PointXYZ | typeof PointXYZI | typeof InterestPoint | typeof PointXYZL | typeof PointXYZRGB | typeof PointXYZRGBA | typeof PointXYZRGBL | typeof Normal | typeof PointNormal | typeof PointXYZRGBNormal | typeof PointXYZINormal | typeof PointXYZLNormal | typeof PointSurfel;
declare type XYZPointTypes = PointXYZ | PointXYZI | PointXYZL | PointXYZRGBA | PointXYZRGB | PointXYZRGBL | InterestPoint | PointNormal | PointXYZRGBNormal | PointXYZINormal | PointXYZLNormal | PointSurfel;

interface PtrType {
    isConst: boolean;
    isReference: boolean;
    isSmartPointer: boolean;
    name: string;
    registeredClass: {
        name: string;
    };
}
interface NativeAPI {
    [key: string]: any;
    $$: {
        count: {
            value: number;
        };
        ptr: number;
        ptrType: PtrType;
        smartPtr?: number;
        smartPtrType?: PtrType;
    };
    clone: () => void;
    delete: () => void;
    deleteLater: () => void;
    isDeleted: () => boolean;
}

declare class Manager {
    private _native;
    constructor(_native: NativeAPI);
    /**
     * Delete a C ++ object
     * {@link https://emscripten.org/docs/porting/connecting_cpp_and_javascript/embind.html?highlight=clone#memory-management}
     */
    delete(): void;
    isDeleted(): boolean;
    /**
     * {@link https://emscripten.org/docs/porting/connecting_cpp_and_javascript/embind.html?highlight=clone#cloning-and-reference-counting}
     * @returns A new handle
     */
    clone(): void;
}

declare class Vector<T> {
    _native: NativeAPI;
    manager: Manager;
    constructor(_native: NativeAPI);
    get size(): number;
    set(index: number, value: T): boolean;
    get(index: number): T;
    push(value: T): void;
    isEmpty(): boolean;
    resize(count: number, value?: T): void;
    clear(): void;
}
declare class PCLHeader {
    _native: NativeAPI;
    manager: Manager;
    constructor(_native: NativeAPI);
    get seq(): number;
    get stamp(): bigint;
    get frameId(): string;
}
declare class Points<T extends PointTypes> extends Vector<T> {
    private readonly _PT;
    constructor(_native: NativeAPI);
    get(index: number): T;
}
declare class PointCloud<T extends PointTypes = PointXYZ> {
    readonly _PT: PointTypesTypeof;
    _native: NativeAPI;
    manager: Manager;
    private _points?;
    constructor(_PT?: PointTypesTypeof, _native?: NativeAPI);
    get isOrganized(): boolean;
    get isDense(): boolean;
    set width(v: number);
    get width(): number;
    set height(v: number);
    get height(): number;
    get header(): PCLHeader;
    get size(): number;
    get points(): Points<T>;
    /**
     * Removes all points in a cloud and sets the width and height to 0.
     */
    clear(): void;
    /**
     * Resizes the container to contain `count` elements
     * @params count - New size of the point cloud
     * @params pt - The value to initialize the new points with
     */
    resize(count: number, pt?: T): void;
    /**
     * Insert a new point in the cloud, at the end of the container.
     * @description This breaks the organized structure of the cloud by setting the height to 1!
     * @params pt - The point to insert
     */
    addPoint(pt?: T | null): void;
}

interface CloudProperties {
    sizeAttenuation: boolean;
    size: number;
    color: ColorRepresentation;
    id: string;
}
declare class PointCloudViewer {
    scene: Scene;
    private camera;
    private renderer;
    private axesHelper?;
    private gridHelper?;
    private controls;
    private clouds;
    private cloudProperties;
    constructor(canvas: HTMLCanvasElement, width?: number, height?: number);
    addPointCloud(cloud: PointCloud<XYZPointTypes>, id?: string): void;
    addPointCloudByUrl(url: string, id?: string, onProgress?: ((event: ProgressEvent<EventTarget>) => void) | undefined): Promise<void>;
    addPointCloudByData(data: ArrayBuffer, id?: string): Promise<void>;
    removePointCloud(id?: string): void;
    setPointCloudProperties(properties?: Partial<CloudProperties>): void;
    setBackgroundColor(bgc: ColorRepresentation): void;
    setCameraParameters(properties: {
        fov: number;
        aspect: number;
        near: number;
        far: number;
        position?: Pick<Vector3, 'x' | 'y' | 'z'>;
    }): void;
    setOrbitControls(properties: {
        enableRotate?: boolean;
        enableZoom?: boolean;
        enablePan?: boolean;
        enableDamping?: boolean;
        enabled?: boolean;
        minDistance?: number;
        maxDistance?: number;
        target?: Pick<Vector3, 'x' | 'y' | 'z'>;
    }): void;
    setAxesHelper(properties: {
        visible: boolean;
        size?: number;
    }): void;
    setGridHelper(properties: {
        visible: boolean;
        size?: number;
        divisions?: number;
    }): void;
    setSize(width: number, height: number): void;
    show(): void;
    hidden(): void;
    destroy(): void;
    private render;
    private createOrbitControls;
    private addPointCloudToScene;
}

export { PointCloudViewer as default };
  
export as namespace PointCloudViewer;
